CREATE TABLE bg_bug (
  id int(11) NOT NULL auto_increment,
  zadavatel varchar(16) NOT NULL,
  resitel varchar(16) NOT NULL,
  nazev varchar(64) NOT NULL,
  popis text NOT NULL,
  datum timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  produkt varchar(16),
  stav int(11),
  PRIMARY KEY  (id)
) TYPE=INNODB;

CREATE TABLE bg_komentar (
  id int(11) NOT NULL auto_increment,
  odpoved_na int(11) default null,
  datum timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  nazev varchar(256) NOT NULL,
  popis text NOT NULL,
  autor varchar(16) NOT NULL,
  bug int(11) NOT NULL,
  PRIMARY KEY  (id)
) TYPE=INNODB;

CREATE TABLE bg_produkt (
  kod varchar(16) NOT NULL,
  nazev varchar(256) NOT NULL,
  popis text NOT NULL,
  spravce varchar(16) NOT NULL,
  PRIMARY KEY  (kod)
) TYPE=INNODB;

CREATE TABLE bg_stav (
  id int(11) NOT NULL auto_increment,
  nazev varchar(16) NOT NULL,
  popis text NOT NULL,
  PRIMARY KEY  (id)
) TYPE=INNODB;

CREATE TABLE bg_uzivatel (
  login varchar(16) NOT NULL,
  heslo varchar(256) NOT NULL,
  jmeno varchar(32) NOT NULL,
  prijmeni varchar(32) NOT NULL,
  email varchar(32) NOT NULL,
  PRIMARY KEY  (login)
) TYPE=INNODB;


ALTER TABLE bg_bug ADD FOREIGN KEY (zadavatel) REFERENCES bg_uzivatel(login);
ALTER TABLE bg_bug ADD FOREIGN KEY (resitel) REFERENCES bg_uzivatel(login);
ALTER TABLE bg_bug ADD FOREIGN KEY (produkt) REFERENCES bg_produkt(kod);
ALTER TABLE bg_bug ADD FOREIGN KEY (stav) REFERENCES bg_stav(id);

ALTER TABLE bg_komentar ADD FOREIGN KEY (odpoved_na) REFERENCES bg_komentar(id);
ALTER TABLE bg_komentar ADD FOREIGN KEY (bug) REFERENCES bg_bug(id);
ALTER TABLE bg_komentar ADD FOREIGN KEY (autor) REFERENCES bg_uzivatel(login);

ALTER TABLE bg_produkt ADD FOREIGN KEY (spravce) REFERENCES bg_uzivatel(login);
